
#include "GLOBAL_DEFS.h"

#define PI 		3.14159265358

extern SINE_TABLE[13];

void PWM_Interrupt(void) 
{
	static unsigned int cnt=0;			
	
	//*AT91C_AIC_EOICR=0; //Acknowledge IRQ	
	
	//* Acnloledge the Fast Forcing
	//AT91C_BASE_AIC->AIC_ICCR= 0x1 << AT91C_ID_PWMC | 0x01;
		
	// wegen errdata
	while(AT91C_BASE_PWMC->PWMC_CH[1].PWMC_CCNTR < 2);
		
    
  	// update PWM Register
    AT91F_PWMC_UpdateChannel(AT91C_BASE_PWMC, SINE_PWM, SINE_TABLE[cnt]);
    // It is forbidden to continue before updating of the PWM period
    while(AT91C_BASE_PWMC->PWMC_ISR != AT91C_PWMC_CHID1); 
    	
    	
    cnt++;
		
	if (cnt == 7)							
	{		
		// LOW an PA15 --> Triggersignal fr den Oszi		 
		AT91F_PIO_ClearOutput( AT91C_BASE_PIOA, (1<<15));
	}	
	
	if (cnt == 13)							
	{													
		cnt = 0;										
														
		// HIGH an PA15 --> Triggersignal fr den Oszi     
		AT91F_PIO_SetOutput( AT91C_BASE_PIOA, (1<<15));	
	}
	
	
	
}



void PWM_InitSinewave(void)
{
  unsigned char i;
  double helpFreq1;

  
  for(i=0; i<13; i++)
   {
    helpFreq1=((2*PI*75)/975)*i;

    SINE_TABLE[i]=(sin(helpFreq1)+1) * 0.5 * ((EXT_OSC) / (975) / 2);//8200;//16400;//((EXT_OSC) / (SINE.PWMFREQ1 * 2)); //(SINE.GAIN/100)
   }  
}


void PWM_Init(void)
{
	AT91F_PWMC_CfgPMC();
	AT91C_BASE_PWMC->PWMC_MR = 0;
	
	AT91F_PIO_CfgPeriph(
			AT91C_BASE_PIOA,					
	        ((unsigned int) AT91C_PA0_PWM0) |	
	        ((unsigned int) AT91C_PA1_PWM1) |
	        ((unsigned int) AT91C_PA2_PWM2),	
			((unsigned int) AT91C_PA7_PWM3)); 
	
	// setup the channel mode registers -->PA0
    AT91C_BASE_PWMC_CH0->PWMC_CMR = MCKtoPWM | CPD_OFF | CPOL_ON | CALG_ON;
    // setup the period registers
    AT91C_BASE_PWMC_CH0->PWMC_CPRDR = EXT_OSC / 4096;
    // setup the duty cycle registers (first value)
    AT91C_BASE_PWMC_CH0->PWMC_CDTYR = EXT_OSC / 4096 / 3;
    		
    		
    // setup sine wave --> PA1
   	// setup the channel mode registers
    AT91C_BASE_PWMC_CH1->PWMC_CMR = MCKtoPWM | CPD_OFF | CPOL_ON | CALG_ON;
    // setup the period registers
    AT91C_BASE_PWMC_CH1->PWMC_CPRDR = EXT_OSC / 975 / 2;//(EXT_OSC) / (SINE.PWMFREQ1);// 8200;//16400;//(EXT_OSC) / (SINE.PWMFREQ1 * 2);
    // setup the duty cycle registers (first value)
    AT91C_BASE_PWMC_CH1->PWMC_CDTYR = EXT_OSC / 975 / 4;//EXT_OSC / SINE.PWMFREQ1 / 4;
   	// Prevent any bad state of this register: Read it clear all set bit
    AT91C_BASE_PWMC->PWMC_ISR;			
   	
   	
   	//* set the Fast Forcing interrupt
    //AT91C_BASE_AIC->AIC_FFER = 0x1 << AT91C_ID_PWMC;  // FAST
    //AT91C_BASE_AIC->AIC_IECR = 0x1 << AT91C_ID_PWMC ; // IMR
   	AT91F_AIC_ConfigureIt(AT91C_BASE_AIC,
                          AT91C_ID_PWMC,
                          6,//AT91C_AIC_PRIOR_HIGHEST,
                          0x2 <<  5,//AT91C_AIC_SRCTYPE_INT_POSITIVE_EDGE//AT91C_AIC_SRCTYPE_INT_HIGH_LEVEL,
                          PWM_Interrupt);  
	AT91F_AIC_EnableIt(AT91C_BASE_AIC, AT91C_ID_PWMC);
	PWM_InitSinewave(); 
			
    // setup the channel mode registers -->PA2
    AT91C_BASE_PWMC_CH2->PWMC_CMR = MCKtoPWM | CPD_OFF | CPOL_ON | CALG_ON;
    // setup the period registers
    AT91C_BASE_PWMC_CH2->PWMC_CPRDR = EXT_OSC / 4096;
    // setup the duty cycle registers (first value)
    AT91C_BASE_PWMC_CH2->PWMC_CDTYR = EXT_OSC / 4096 / 3;
    
    
    // setup the channel mode registers -->PA7
    AT91C_BASE_PWMC_CH3->PWMC_CMR = MCKtoPWM | CPD_OFF | CPOL_ON | CALG_ON;
    // setup the period registers
    AT91C_BASE_PWMC_CH3->PWMC_CPRDR = EXT_OSC / 4096;
    // setup the duty cycle registers (first value)
    AT91C_BASE_PWMC_CH3->PWMC_CDTYR = EXT_OSC / 4096 / 3;
    
			
	AT91F_PWMC_StartChannel(AT91C_BASE_PWMC,
							AT91C_PWMC_CHID0 |
							AT91C_PWMC_CHID1 |
	       					AT91C_PWMC_CHID2 |	
							AT91C_PWMC_CHID3 );
	
	AT91F_PWMC_InterruptEnable(AT91C_BASE_PWMC,AT91C_PWMC_CHID1); //AT91C_PWMC_CHID1
}


